<script>
import store from "@state/store";

export default {
  name: "ChatSidebar",
  data() {
    return {
      spokesPersons : null,
      currentUser : store.state.auth.currentUser,
      currentMessage : [],
      spokesCurrentPerson : null
    }
  },
  mounted() {
    this.loadSpokesPersons()
  },
  methods : {
    async loadSpokesPersons() {
      this.spokesPersons = await this.$store.dispatch('message/spokespersons')
    },
    async changeCurrentSpokesPerson(user) {
      this.currentSpokesPerson = user;
      this.currentMessage.recipient_id = user.id
      this.spokesCurrentPerson = user
      this.$emit('changeCurrentSpokesPerson', user)
    }
  }
}
</script>

<template>
  <div class="card">
    <div class="card-body">
      <div class="media mb-3">
        <img :src='this.currentUser.media()' class="mr-2 rounded-circle" height="42" alt="Brandon Smith">
        <div class="media-body mt-2">
          <h5 class="mt-0 mb-0 font-15">
            <span class="text-reset">{{ this.currentUser.fullname }}</span>
          </h5>
        </div>
        <div>
          <a href="#" class="text-reset font-20">
            <i class="mdi mdi-cog-outline"></i>
          </a>
        </div>
      </div>
      <h6 class="font-13 text-muted text-uppercase mb-2">Contacts</h6>
      <div id="side-contacts" class="row">
        <div class="col">
          <a v-for="spokesPerson in spokesPersons" v-if="spokesPersons && spokesPersons.length" href="#" class="text-body" @click="changeCurrentSpokesPerson(spokesPerson.user)">
            <div class="media p-2" :class="{ 'bg-light': spokesCurrentPerson && spokesPerson.user.id === spokesCurrentPerson.id }">
              <img :src="spokesPerson.user.media()" class="mr-2 rounded-circle" height="42">
              <div class="media-body">
                <h5 class="mt-0 mb-0 font-14">
                  <span class="float-right text-muted font-weight-normal font-12">{{ spokesPerson.last_message.formatCreatedAt() }}</span>
                  {{ spokesPerson.user.fullname }}
                </h5>
                <p class="mt-1 mb-0 text-muted font-14">
                  <span class="w-75">{{ spokesPerson.last_message.content }}</span>
                </p>
              </div>
            </div>
          </a>
          <p v-if="spokesPersons && !spokesPersons.length" class="text-muted mt-3">Aucun contact pour le moment</p>
        </div>
      </div>
    </div>
  </div>
</template>
